---
id: racing4everyone-api
name: Racing4Everyone (API)
description: "Racing4Everyone (R4E) is a Private Torrent Tracker for RACING"
language: en-US
type: private
encoding: UTF-8
links:
  - https://racing4everyone.eu/
legacylinks:
  - https://racing4everyone.jp/

caps:
  categorymappings:
    - {id: 72, cat: TV/Sport, desc: "AMA Pro Motocross"}
    - {id: 73, cat: TV/Sport, desc: "AMA Supercross"}
    - {id: 76, cat: TV/Sport, desc: "ARCA"}
    - {id: 77, cat: TV/Sport, desc: "Blancpain GT"}
    - {id: 1, cat: TV/Sport, desc: "BTCC"}
    - {id: 60, cat: TV/Sport, desc: "Drag Racing"}
    - {id: 3, cat: TV/Sport, desc: "DTM"}
    - {id: 61, cat: TV/Sport, desc: "ERC"}
    - {id: 81, cat: TV/Sport, desc: "Extreme E"}
    - {id: 67, cat: TV/Sport, desc: "Formula 1"}
    - {id: 22, cat: TV/Sport, desc: "Formula 2"}
    - {id: 68, cat: TV/Sport, desc: "Formula 3"}
    - {id: 23, cat: TV/Sport, desc: "Formula E"}
    - {id: 62, cat: TV/Sport, desc: "Indycar Series"}
    - {id: 26, cat: TV/Sport, desc: "MotoGP-2-3-E"}
    - {id: 82, cat: TV/Sport, desc: "Motorcycle Speedway"}
    - {id: 31, cat: TV/Sport, desc: "Nascar"}
    - {id: 25, cat: TV/Sport, desc: "Other Bikes"}
    - {id: 69, cat: TV/Sport, desc: "Other Cars"}
    - {id: 78, cat: TV/Sport, desc: "Porsche Supercup"}
    - {id: 32, cat: TV/Sport, desc: "Stock Car Brazil"}
    - {id: 63, cat: TV/Sport, desc: "Supercars"}
    - {id: 83, cat: TV/Sport, desc: "Super GT"}
    - {id: 80, cat: TV/Sport, desc: "Touring Cars"}
    - {id: 57, cat: TV/Sport, desc: "WEC"}
    - {id: 50, cat: TV/Sport, desc: "WRC"}
    - {id: 56, cat: TV/Sport, desc: "WRX"}
    - {id: 71, cat: TV/Sport, desc: "WSBK"}
    - {id: 74, cat: TV/Sport, desc: "WTCR"}
    - {id: 58, cat: TV/Sport, desc: "W Series"}
    - {id: 55, cat: TV/Sport, desc: "Season Reviews"}
    - {id: 66, cat: TV/Sport, desc: "Documentaries"}
    - {id: 2, cat: TV/Sport, desc: "TV-Documentaries"}
    - {id: 24, cat: TV/Sport, desc: "Misc"}
    - {id: 70, cat: TV/Sport, desc: "Motorsport Movies"}
    - {id: 79, cat: TV/Sport, desc: "TV Series"}

  modes:
    search: [q]
    tv-search: [q, season, ep]

settings:
  - name: apikey
    type: text
    label: APIKey
  - name: info_key
    type: info
    label: About your API key
    default: "Find or Generate a new API Token by accessing your <a href=\"https://racing4everyone.eu/\" target=\"_blank\">Racing4Everyone</a> account <i>My Settings</i> page and clicking on the <b>API Key</b> tab."
  - name: freeleech
    type: checkbox
    label: Search freeleech only
    default: false
  - name: single_file_release_use_filename
    type: checkbox
    label: Use filename as title for single file releases
    default: true
  - name: sort
    type: select
    label: Sort requested from site
    default: created_at
    options:
      created_at: created
      seeders: seeders
      size: size
      name: title
  - name: type
    type: select
    label: Order requested from site
    default: desc
    options:
      desc: desc
      asc: asc
  - name: info_activity
    type: info
    label: Account Inactivity
    default: "After 6 months without any log in or usage of your account, it will be pruned and can only be reactivated by a staff member. Make sure to keep your account active and do not use programs to keep your account active, as your account may still get pruned."

login:
  path: /api/torrents
  method: get
  inputs: {} # TODO: remove in v10
  error:
    - selector: a[href*="/login"]
      message:
        text: "The API key was not accepted by {{ .Config.sitelink }}."
    - selector: :root:contains("Account is Banned")

search:
  paths:
    # https://hdinnovations.github.io/UNIT3D/torrent_api.html
    # https://github.com/HDInnovations/UNIT3D/blob/master/app/Http/Controllers/API/TorrentController.php#L657
    - path: api/torrents/filter
      response:
        type: json

  headers:
    Authorization: ["Bearer {{ .Config.apikey }}"]

  inputs:
  # if we have an id based search, add Season and Episode as query in name for UNIT3D < v6.  Else pass S/E Params for UNIT3D >= v6
    $raw: "{{ range .Categories }}&categories[]={{.}}{{end}}"
    name: "{{ .Keywords }}"
    # seasonNumber: "{{ .Query.Season }}" # not supported
    # episodeNumber: "{{ .Query.Ep }}" # not supported
    "free[]": "{{ if .Config.freeleech }}100{{ else }}{{ end }}"
    sortField: "{{ .Config.sort }}"
    sortDirection: "{{ .Config.type }}"
    perPage: 100

  keywordsfilters:
    - name: re_replace
      args: ["\\.", " "]

  rows:
    selector: data
    attribute: attributes

  fields:
    category:
      selector: category_id
    title_optional:
      selector: name
    title_filename:
      selector: "files[0].name"
      optional: true
    files:
      selector: num_file
    title:
      text: "{{ if and (.Config.single_file_release_use_filename) (eq .Result.files \"1\") (.Result.title_filename) }}{{ .Result.title_filename }}{{ else }}{{ .Result.title_optional }}{{ end }}"
    details:
      selector: details_link
    download:
      selector: download_link
    poster:
      selector: meta.poster
      filters:
        - name: replace
          args: ["https://via.placeholder.com/90x135", ""]
    _internal:
      selector: internal
      case:
        False: "{{ .False }}"
        True: "{{ .True }}"
    description:
      text: "{{ if .Result._internal }}Internal{{ else }}{{ end }}"
    seeders:
      selector: seeders
    leechers:
      selector: leechers
    grabs:
      selector: times_completed
    date:
      # "created_at": "2021-10-18T00:34:50.000000Z" is returned by Newtonsoft.Json.Linq as 18/10/2021 00:34:50
      selector: created_at
      filters:
        - name: append
          args: " +00:00" # GMT
        - name: dateparse
          args: "MM/dd/yyyy HH:mm:ss zzz"
    size:
      selector: size
    _featured:
      selector: featured
      case:
        False: "{{ .False }}"
        True: "{{ .True }}"
    downloadvolumefactor_freeleech:
      # api returns 0%, 25%, 50%, 75%, 100%
      selector: freeleech
      case:
        0%: 1 # not free
        25%: 0.75
        50%: 0.5
        75%: 0.25
        100%: 0 # freeleech
        "*": 0 # catch errors
    downloadvolumefactor:
      text: "{{ if .Result._featured }}0{{ else }}{{ .Result.downloadvolumefactor_freeleech }}{{ end }}"
    uploadvolumefactor_double_upload:
      # api returns False, True
      selector: double_upload
      case:
        False: 1 # normal
        True: 2 # double
    uploadvolumefactor:
      text: "{{ if .Result._featured }}2{{ else }}{{ .Result.uploadvolumefactor_double_upload }}{{ end }}"
# global MR is 0.4 but torrents must be seeded for 2 days regardless of ratio
#    minimumratio:
#      text: 0.4
    minimumseedtime:
      # 2 days (as seconds = 2 x 24 x 60 x 60)
      text: 172800
# json UNIT3D 9.1.7 (custom)
